/// <reference types="node" />
import XLSX, { AOA2SheetOpts, ParsingOptions, Sheet2JSONOpts, WritingOptions } from 'xlsx';
export declare const parse: (mixed: unknown, options?: Sheet2JSONOpts & ParsingOptions) => {
    name: string;
    data: unknown[];
}[];
export declare const parseMetadata: (mixed: unknown, options?: ParsingOptions) => {
    name: string;
    data: XLSX.Range | null;
}[];
export declare type WorkSheet<T = unknown> = {
    name: string;
    data: T[][];
    options: AOA2SheetOpts;
};
export declare const build: (worksheets: WorkSheet[], options?: WritingOptions & {
    sheetOptions?: AOA2SheetOpts;
}) => Buffer;
declare const _default: {
    parse: (mixed: unknown, options?: XLSX.Sheet2JSONOpts & XLSX.ParsingOptions) => {
        name: string;
        data: unknown[];
    }[];
    parseMetadata: (mixed: unknown, options?: XLSX.ParsingOptions) => {
        name: string;
        data: XLSX.Range | null;
    }[];
    build: (worksheets: WorkSheet<unknown>[], options?: XLSX.WritingOptions & {
        sheetOptions?: XLSX.AOA2SheetOpts | undefined;
    }) => Buffer;
};
export default _default;
